
*WindRose Generator* is a powerful Python tool designed to transform raw wind data (speed and direction) from Excel files into professional wind rose diagrams. Tailored for environmental scientists, meteorologists, and researchers, this library simplifies the process of generating insightful visualizations while offering extensive customization:  

#### Key Features:  
- *Excel Integration*: Directly import wind data from .xlsx or .csv files.  
- *Customization*:  
  - Adjust *colors, **fonts, and **labels* for axes, titles, and legends.  
  - Modify *plot styles* (e.g., bar width, transparency, radial bins).  
  - Choose *color palettes* for wind speed gradients.  
- *Export Flexibility*: Save plots as PNG, SVG, or jpg for publications.  
- *Automated Analysis*: Calculate frequency distributions and statistical summaries.  





For Test run Main.py and give it the data.